## why3 1.8.2

=== examples/euler001/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=euler001

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../euler001.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) zarith.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../euler001.mlw
	$(WHY3) extract -D ocaml64 $< -o $@

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* euler001__*.ml* int__*.ml*

=== examples/residual/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=residual

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../residual.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) zarith.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../residual.mlw
	$(WHY3) extract -D ocaml64 -L . -L .. -D residual.drv -o $@ residual.ResidualOCaml

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte

=== examples/split_string/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=split_string

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../split_string.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) zarith.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../split_string.mlw
	$(WHY3) extract -D ocaml64 -L . -L .. -D split_string.drv -o $@ split_string.SplitStringOCaml

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte

=== examples/string_base64_encoding/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=base64
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../string_base64_encoding.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../string_base64_encoding.mlw
	$(WHY3) extract -D ocaml64 -L .. -o $@ ../string_base64_encoding.mlw

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f gcd__*.ml*


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== examples/sudoku/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN =sudoku
OBJ=$(GEN)

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT = ocamlopt -noassert -inline 1000

all: $(MAIN).opt

extract: $(GENML)

doc:
	$(WHY3) doc ../sudoku.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO) $(MAIN).cmo
	ocamlc -g $(INCLUDE) zarith.cma -o $@ $^

$(MAIN).opt: $(CMX) $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../sudoku.mlw
	$(WHY3) extract -D ocaml64 --recursive -o $@ -L .. sudoku.Test

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml-ppx -package js_of_ocaml-lwt

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml +zarith_stubs_js/biginteger.js +zarith_stubs_js/runtime.js $(JSMAIN).byte

$(JSMAIN).byte: $(CMO) $(JSMAIN).cmo
	$(JSOCAMLC) $(INCLUDE) zarith.cma -o $@ -linkpkg $^

%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.annot *.o *.cm[xio] $(MAIN).opt $(MAIN).byte
	rm -f sudoku__*.ml why3__*.ml
	rm -f int__Int.ml map__Map.ml array__Array.ml

=== examples/vstte10_max_sum/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
OBJ=vstte10_max_sum

ML  = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(ML)

doc:
	$(WHY3) doc ../vstte10_max_sum.mlw
	$(WHY3) session html .

$(MAIN).byte: $(CMO)  $(MAIN).cmo
	ocamlc $(INCLUDE) zarith.cma -o $@ $^

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(ML): ../vstte10_max_sum.mlw
	$(WHY3) extract -D ocaml64 -o $@ $^

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

%.cmo: %.ml
	ocamlc $(INCLUDE) -annot -c $<

%.cmi: %.mli
	ocamlc $(INCLUDE) -annot -c $<

clean::
	rm -f $(ML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f why3__*.ml* vstte10_max_sum__*.ml* int__*.ml*

=== examples/vstte12_combinators/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../bin/why3.opt
  WHY3SHARE=../../share
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
  WHY3SHARE=$(shell $(WHY3) --print-datadir)
endif

include $(WHY3SHARE)/Makefile.config

ifeq ($(BENCH),yes)
  INCLUDE += -I ../../lib/why3
endif

MAIN=main
GEN=vstte12_combinators
OBJ=$(GEN) parse

GENML = $(addsuffix .ml, $(GEN))
ML = $(addsuffix .ml, $(OBJ))
CMO = $(addsuffix .cmo, $(OBJ))
CMX = $(addsuffix .cmx, $(OBJ))

OCAMLOPT=ocamlopt -noassert -inline 1000

all: $(MAIN).$(OCAMLBEST)

extract: $(GENML)

doc:
	$(WHY3) doc ../vstte12_combinators.mlw
	$(WHY3) session html .

$(MAIN).opt: $(CMX)  $(MAIN).cmx
	$(OCAMLOPT) $(INCLUDE) zarith.cmxa -o $@ $^

$(MAIN).cmx: $(CMX)

$(GENML): ../vstte12_combinators.mlw
	$(WHY3) extract -D ocaml64 -o $@ $<

%.cmx: %.ml
	$(OCAMLOPT) $(INCLUDE) -annot -c $<

clean::
	rm -f $(GENML) *.cm[xio] *.o *.annot $(MAIN).opt $(MAIN).byte
	rm -f vstte12_combinators__*.ml*

# javascript


JSMAIN=jsmain

JSOCAMLC=ocamlfind ocamlc -package js_of_ocaml -package js_of_ocaml-ppx -package js_of_ocaml-lwt

$(JSMAIN).js: $(JSMAIN).byte
	js_of_ocaml --pretty --noinline +zarith_stubs_js/biginteger.js +zarith_stubs_js/runtime.js $(JSMAIN).byte


$(JSMAIN).byte: $(CMO) jsmain.ml
#	$(JSOCAMLC) $(INCLUDE) -o $@ -linkpkg $^
	$(JSOCAMLC) $(INCLUDE) zarith.cma -o $@ -linkpkg $^


%.cmo: %.ml
	$(JSOCAMLC) $(INCLUDE) -annot -c $<

%.cmi: %.mli
	$(JSOCAMLC) $(INCLUDE) -annot -c $<


clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

=== bench/extraction/852_int16/Makefile ===

BENCH ?= no

ifeq ($(BENCH),yes)
  WHY3=../../../bin/why3.opt
else
  ifeq ($(BINDIR),)
    WHY3=why3
  else
    WHY3=$(BINDIR)/why3
  endif
endif

.PHONY: clean extract

clean:
	rm -rf build

extract build/852_int16.c:
	mkdir -p build
	$(WHY3) extract -D c -o build/852_int16.c 852_int16.mlw

build/tests: build/852_int16.c
	gcc -Wall -g -pedantic -Wno-unused-function -std=c11 build/852_int16.c main.c -o build/tests

=== bench/extraction/test/Makefile ===
include ../../../share/Makefile.config

WHY3 = ../../../bin/why3.$(OCAMLBEST)

.PHONY: extract doc

main.opt: test.ml main.ml
	ocamlopt $(INCLUDE) zarith.cmxa $^ -o main.opt

extract: test.ml

doc:

%.ml: ../%.mlw
	$(WHY3) extract -D ocaml64 $< > $@

%.cmo: %.ml
	ocamlc $(INCLUDE) -c $<

%.cmx: %.ml
	ocamlopt $(INCLUDE) -c $<

clean::
	rm -f test.ml main.opt *.cm*

=== examples/multiprecision/plots/Makefile ===
all:
	./divplot &
	./divrelative &
	./mulrelative &
	./addrelative &
	./addplot &
	./minidivrelative &
	./minimulrelative &
	./miniaddrelative &
#	./gmpdivplot &
#	./gmpmulplot &
#	./gmpaddplot &
	./toomrelative &
	./minitoomrelative &
	./powmrelative

=== debian/changelog ===
why3 (1.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Ralf Treinen <treinen@debian.org>  Tue, 23 Sep 2025 22:40:18 +0200

=== debian/control ===
Source: why3
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Ralf Treinen <treinen@debian.org>
Build-Depends:
  debhelper-compat (= 13), dh-ocaml,
  autoconf,
  ocaml,
  ocaml-findlib,
  menhir (>= 20200123),
  libmenhir-ocaml-dev (>= 20200123),
  libzarith-ocaml-dev,
  libsqlite3-ocaml-dev,
  libzip-ocaml-dev,
  libnum-ocaml-dev,
  libocamlgraph-ocaml-dev (>= 1.8.2),
  liblablgtk3-ocaml-dev, liblablgtksourceview3-ocaml-dev,
  tex-common
Build-Depends-Indep:
  python3-sphinx, python3-sphinxcontrib.bibtex,
  texlive-plain-generic,
  texlive-latex-recommended, texlive-latex-extra,
  texlive-fonts-recommended,
  texlive-bibtex-extra,
  tex-gyre,
  graphviz
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.why3.org/
Vcs-Git: https://salsa.debian.org/ocaml-team/why3.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/why3

Package: why3
Architecture: any
Depends:
  ${shlibs:Depends},
  ${ocaml:Depends},
  ${misc:Depends},
Recommends: cvc4 (<< 1.9) | cvc5 (<< 1.3) | spass | z3 (<< 4.14)
Suggests: why3-examples
Breaks: libwhy3-ocaml-dev (<< 1.8), why3-coq (<< 1.8)
Replaces: libwhy3-ocaml-dev (<< 1.8), why3-coq (<< 1.8)
Description: Software verification platform
 Why3 is a platform for deductive program verification. It provides a
 rich language for specification and programming, called WhyML, and
 relies on external theorem provers, both automated and interactive,
 to discharge verification conditions. Why3 comes with a standard
 library of logical theories (integer and real arithmetic, Boolean
 operations, sets and maps, etc.) and basic programming data
 structures (arrays, queues, hash tables, etc.). A user can write
 WhyML programs directly and get correct-by-construction OCaml
 programs through an automated extraction mechanism. WhyML is also
 used as an intermediate language for the verification of C, Java, or
 Ada programs.
 .
 Why3 is a complete reimplementation of the former Why platform. Among
 the new features are: numerous extensions to the input language, a
 new architecture for calling external provers, and a well-designed
 API, allowing to use Why3 as a software library. An important
 emphasis is put on modularity and genericity, giving the end user a
 possibility to easily reuse Why3 formalizations or to add support for
 a new external prover if wanted.

Package: libwhy3-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Section: ocaml
Description: OCaml librariries for why3 (dev)
 This package contains the libraries of the why3 verification platform
 for developing applications using why3.

Package: why3-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: why3
Description: Examples for the why3 verification platform
 This package contains examples, both of program verification tasks
 and pure logical verification tasks, for the why3 software verification
 platform.

Package: why3-doc-html
Architecture: all
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-underscore,
  libjs-mathjax,
  libjs-sphinxdoc
Suggests: why3
Description: HTML Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in HTML format.

Package: why3-doc-pdf
Architecture: all
Depends: ${misc:Depends}
Suggests: why3
Description: PDF Documentation of the why3 verification platform
 This package contains the tutorial and reference manual of the
 why3 verification platform in PDF format.

=== debian/tests/control ===
Tests: why3+cvc4
Depends: why3, cvc4 (<< 1.9), ocaml-native-compilers
Restrictions: skip-not-installable

Tests: why3+cvc5
Depends: why3, cvc5 (<< 1.3), ocaml-native-compilers
Restrictions: skip-not-installable

Tests: why3+spass
Depends:why3, spass, ocaml-native-compilers
Restrictions: skip-not-installable

Tests: why3+z3
Depends:why3, z3 (<< 4.14), ocaml-native-compilers
Restrictions: skip-not-installable

=== debian/watch ===
version=4

opts="searchmode=plain" \
 https://gitlab.inria.fr/why3/@PACKAGE@/tags?sort=updated_desc \
 -/archive/\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
